<?php  namespace App\Controllers\Configuracion;


use App\Controllers\BaseResourceController;

use App\Models\Collection;

use App\Entities\Configuracion\PapelImpresionTipologia;

use App\Models\Configuracion\PapelImpresionTipologiaModel;

use App\Models\Configuracion\PapelImpresionModel;

use
    DataTables\Editor,
    DataTables\Database,
    DataTables\Editor\Field,
    DataTables\Editor\Format,
    DataTables\Editor\Mjoin,
    DataTables\Editor\Options,
    DataTables\Editor\Upload,
    DataTables\Editor\Validate,
    DataTables\Editor\ValidateOptions;


class Papelimpresiontipologias extends \App\Controllers\BaseResourceController {

    protected $modelName = PapelImpresionTipologiaModel::class;
    protected $format = 'json';

    protected static $singularObjectName = 'Papel Impresion Tipologia';
    protected static $singularObjectNameCc = 'papelImpresionTipologia';
    protected static $pluralObjectName = 'Papel Impresion Tipologias';
    protected static $pluralObjectNameCc = 'papelImpresionTipologias';

    protected static $controllerSlug = 'papelimpresiontipologias';

    protected static $viewPath = 'themes/vuexy/form/configuracion/papel/';

    protected $indexRoute = 'papelImpresionTipologiaList';

    

    public function initController(\CodeIgniter\HTTP\RequestInterface $request, \CodeIgniter\HTTP\ResponseInterface $response, \Psr\Log\LoggerInterface $logger) {
        $this->viewData['pageTitle'] = lang('ImpresionTipologias.moduleTitle');
        $this->viewData['usingSweetAlert'] = true;
        parent::initController($request, $response, $logger);
    }


    public function index() {
        
        $viewData = [
                'currentModule' => static::$controllerSlug,
                'pageSubTitle' => lang('Basic.global.ManageAllRecords', [lang('ImpresionTipologias.papelImpresionTipologia')]),
                'papelImpresionTipologia' => new PapelImpresionTipologia(),
                'usingServerSideDataTable' => true,
                
            ];

        $viewData = array_merge($this->viewData, $viewData); // merge any possible values from the parent controller class

        //return view(static::$viewPath.'viewPapelImpresionTipologiaList', $viewData);
    }


    public function add() {
        
        

        

        if ($this->request->getPost()) :

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

			$sanitizedData = $this->sanitized($postData, $nullIfEmpty);

            $noException = true;
            $successfulResult = false; // for now

            if ($this->canValidate()) :
                try {
                    $successfulResult = $this->model->skipValidation(true)->save($sanitizedData);           
                } catch (\Exception $e) {
                    
                    $noException = false;
                    $this->dealWithException($e);
                }
            else:
                $this->viewData['errorMessage'] = lang('Basic.global.formErr1', [lang('Basic.global.record')]);
                $this->session->setFlashdata('formErrors', $this->model->errors());
                endif;

            $thenRedirect = false;  // Change this to false if you want your user to stay on the form after submission
            
            if ($noException && $successfulResult) :
                
                $id = $this->model->db->insertID();

                $message = lang('Basic.global.saveSuccess', [lang('Basic.global.record')]) . '.';
                
                if ($thenRedirect) :
                    if (!empty($this->indexRoute)) :
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    //$this->session->setFlashData('sweet-success', $message);
                    $newTokenHash = csrf_hash();
                    $csrfTokenName = csrf_token();  
                    $output = array(
                        'success'		=>	'yes',
                        $csrfTokenName => $newTokenHash
                    );
                    return json_encode($output);
                endif;

            endif; // $noException && $successfulResult

        endif; // ($requestMethod === 'post')

        $this->viewData['papelImpresionTipologia'] = isset($sanitizedData) ? new PapelImpresionTipologia($sanitizedData) : new PapelImpresionTipologia();
		$this->viewData['papelImpresionList'] = $this->getPapelImpresionListItems($papelImpresionTipologia->papel_impresion_id ?? null);
		$this->viewData['tipoList'] = $this->getTipoOptions();

        $this->viewData['formAction'] = route_to('createPapelImpresionTipologia');

        $this->viewData['boxTitle'] = lang('Basic.global.addNew').' '.lang('ImpresionTipologias.moduleTitle').' '.lang('Basic.global.addNewSuffix');
        
        $newTokenHash = csrf_hash();
        $csrfTokenName = csrf_token();  
        $output = array(
            'success'		=>	'no',
            $csrfTokenName => $newTokenHash
        );
        return json_encode($output);
        //return $this->displayForm(__METHOD__);
    } // end function add()

    public function edit($requestedId = null) {
        
        if ($requestedId == null) :
            return $this->redirect2listView();
        endif;
        $id = filter_var($requestedId, FILTER_SANITIZE_URL);
        $papelImpresionTipologia = $this->model->find($id);

        if ($papelImpresionTipologia == false) :
            $message = lang('Basic.global.notFoundWithIdErr', [mb_strtolower(lang('ImpresionTipologias.papelImpresionTipologia')), $id]);
            return $this->redirect2listView('sweet-error', $message);
        endif;

        

        if ($this->request->getPost()) :

            $nullIfEmpty = true; // !(phpversion() >= '8.1');
        
            $postData = $this->request->getPost();
            
            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);

            $noException = true;
            $successfulResult = false; // for now
            
            if ($this->canValidate()) :
                try {
                    
                    $successfulResult = $this->model->skipValidation(true)->update($id, $sanitizedData);
                } catch (\Exception $e) {
                    $noException = false;
                    $this->dealWithException($e);
                }
            else:
                $this->viewData['warningMessage'] = lang('Basic.global.formErr1', [mb_strtolower(lang('ImpresionTipologias.papelImpresionTipologia'))]);
                $this->session->setFlashdata('formErrors', $this->model->errors());
            
            endif;
            
            $papelImpresionTipologia->fill($sanitizedData);

            $thenRedirect = false;
            
            if ($noException && $successfulResult) :
                $id = $papelImpresionTipologia->id ?? $id;
                $message = lang('Basic.global.updateSuccess', [lang('Basic.global.record')]).'.';

                if ($thenRedirect) :
                    if (!empty($this->indexRoute)) :
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $newTokenHash = csrf_hash();
                    $csrfTokenName = csrf_token();  
                    $output = array(
                        'success'		=>	'yes',
                        $csrfTokenName => $newTokenHash
                    );
            
                    return json_encode($output);
                    //$this->session->setFlashData('sweet-success', $message);
                endif;
        
            endif; // $noException && $successfulResult
        endif; // ($requestMethod === 'post')

        $this->viewData['papelImpresionTipologia'] = $papelImpresionTipologia;
		$this->viewData['papelImpresionList'] = $this->getPapelImpresionListItems($papelImpresionTipologia->papel_impresion_id ?? null);
		$this->viewData['tipoList'] = $this->getTipoOptions();

        $this->viewData['formAction'] = route_to('updatePapelImpresionTipologia', $id);

        $this->viewData['boxTitle'] = lang('Basic.global.edit2').' '.lang('ImpresionTipologias.moduleTitle').' '.lang('Basic.global.edit3');
        
        //return $this->displayForm(__METHOD__, $id);
        $newTokenHash = csrf_hash();
        $csrfTokenName = csrf_token();  
        $output = array(
            'success'		=>	'no',
            $csrfTokenName => $newTokenHash
        );
        return json_encode($output);
    } // end function edit(...)
    

    public function datatable_editor() {
        if ($this->request->isAJAX()) {

            include(APPPATH . "ThirdParty/DatatablesEditor/DataTables.php");

            // Build our Editor instance and process the data coming from _POST
            $response = Editor::inst( $db, 'lg_papel_impresion_tipologias' )
            ->fields(
                Field::inst( 'tipo' )
                    ->validator( Validate::values( array('negro', 'color', 'bicolor') ) ),
                Field::inst( 'negro' )
                    ->validator( 'Validate::numeric', array(
                        'message' =>  lang('ImpresionTipologias.validation.negro.decimal') )
                    )
                    ->validator( 'Validate::notEmpty',array(
                        'message' =>  lang('ImpresionTipologias.validation.negro.required') )
                ),
                Field::inst( 'cyan' )
                    ->validator( 'Validate::numeric', array(
                        'message' =>  lang('ImpresionTipologias.validation.cyan.decimal') )
                    )
                    ->validator( 'Validate::notEmpty',array(
                        'message' =>  lang('ImpresionTipologias.validation.cyan.required') )
                ),
                Field::inst( 'magenta' )
                    ->validator( 'Validate::numeric', array(
                        'message' =>  lang('ImpresionTipologias.validation.magenta.decimal') )
                    )
                    ->validator( 'Validate::notEmpty',array(
                        'message' =>  lang('ImpresionTipologias.validation.magenta.required') )
                ),
                Field::inst( 'amarillo' )
                    ->validator( 'Validate::numeric', array(
                        'message' =>  lang('ImpresionTipologias.validation.amarillo.decimal') )
                    )
                    ->validator( 'Validate::notEmpty',array(
                        'message' =>  lang('ImpresionTipologias.validation.amarillo.required') )
                ),
                Field::inst( 'cg' )
                    ->validator( 'Validate::numeric', array(
                        'message' =>  lang('ImpresionTipologias.validation.amarillo.decimal') )
                    )
                    ->validator( 'Validate::notEmpty',array(
                        'message' =>  lang('ImpresionTipologias.validation.amarillo.required') )
                ),
                Field::inst( 'gota_negro' )
                    ->validator( 'Validate::numeric', array(
                        'message' =>  lang('ImpresionTipologias.validation.gota_negro.decimal') )
                    )
                    ->validator( 'Validate::notEmpty',array(
                        'message' =>  lang('ImpresionTipologias.validation.gota_negro.required') )
                ),
                Field::inst( 'gota_color' )
                    ->validator( 'Validate::numeric', array(
                        'message' =>  lang('ImpresionTipologias.validation.gota_color.decimal') )
                    )
                    ->validator( 'Validate::notEmpty',array(
                        'message' =>  lang('ImpresionTipologias.validation.gota_color.required') )
                ),
                Field::inst( 'papel_impresion_id' ),
                    
            )
            ->validator( function($editor, $action, $data){
                if ($action === Editor::ACTION_CREATE || $action === Editor::ACTION_EDIT){
                    foreach ($data['data'] as $pkey => $values ){
                        $process_data['tipo'] = $data['data'][$pkey]['tipo'];
                        $process_data['papel_impresion_id'] = $data['data'][$pkey]['papel_impresion_id'];
                        $response = $this->model->checkTipo($process_data, $pkey);
                        // No se pueden duplicar valores al crear o al editar
                        if (!empty($response)){
                            return $response;
                        }
                    }
                }
            })
            ->debug(true)
            ->process( $_POST )
            ->data();

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();  
            
            $response[$csrfTokenName] = $newTokenHash;
            
            echo json_encode($response);

        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }
    

    public function datatable() {
        if ($this->request->isAJAX()) {
            $reqData = $this->request->getPost();
            if (!isset($reqData['draw']) || !isset($reqData['columns']) ) {
                $errstr = 'No data available in response to this specific request.';
                $response = $this->respond(Collection::datatable(  [], 0, 0, $errstr ), 400, $errstr);
                return $response;
            }
            $start = $reqData['start'] ?? 0;
            $length = $reqData['length'] ?? 5;
            $search = $reqData['search']['value'];
            $requestedOrder = $reqData['order']['0']['column'] ?? 1;
            $order = PapelImpresionTipologiaModel::SORTABLE[$requestedOrder > 0 ? $requestedOrder : 1];
            $dir = $reqData['order']['0']['dir'] ?? 'asc';

            $resourceData = $this->model->getResource($search)->orderBy($order, $dir)->limit($length, $start)->get()->getResultObject();

            return $this->respond(Collection::datatable(
                $resourceData,
                $this->model->getResource()->countAllResults(),
                $this->model->getResource($search)->countAllResults()
            ));
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function allItemsSelect() {
        if ($this->request->isAJAX()) {
            $onlyActiveOnes = true;
            $reqVal = $this->request->getPost('val') ?? 'id';
            $menu = $this->model->getAllForMenu($reqVal.', papel_impresion_id', 'papel_impresion_id', $onlyActiveOnes, false);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->papel_impresion_id = '- '.lang('Basic.global.None').' -';
            array_unshift($menu , $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function menuItems() {
        if ($this->request->isAJAX()) {
            $searchStr = goSanitize($this->request->getPost('searchTerm'))[0];
            $reqId = goSanitize($this->request->getPost('id'))[0];
            $reqText = goSanitize($this->request->getPost('text'))[0];
            $onlyActiveOnes = false;
            $columns2select = [$reqId ?? 'id', $reqText ?? 'papel_impresion_id'];
            $onlyActiveOnes = false;
            $menu = $this->model->getSelect2MenuItems($columns2select, $columns2select[1], $onlyActiveOnes, $searchStr);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->text = '- '.lang('Basic.global.None').' -';
            array_unshift($menu , $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();  
            $output = array(
                'success'		=>	'yes',
                $csrfTokenName => $newTokenHash
            );
            return json_encode($output);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }


	protected function getPapelImpresionListItems($selId = null) { 
		$data = [''=>lang('Basic.global.pleaseSelectA', [mb_strtolower(lang('PapelImpresions.papelImpresion'))])];
        if (!empty($selId)) :
            		$papelImpresionModel = model('App\Models\Configuracion\PapelImpresionModel');

            $selOption = $papelImpresionModel->where('id', $selId)->findColumn('id');
            if (!empty($selOption)) :
                $data[$selId] = $selOption[0];
            endif;
        endif;
		return $data;
	}


	protected function getTipoOptions() { 
		$tipoOptions = [ 
				'' => lang('Basic.global.pleaseSelect'),
				'negro' => 'negro',
				'color' => 'color',
				'bicolor' => 'bicolor',
			];
		return $tipoOptions;
	}


}
